Subject: Re: [PATCH] refs: exit early from the loop if it is not a main worktree

From: Junio C Hamano <[email-masked]>
Date: Wed, 18 Dec 2024 17:10:24 -0800

Eric Sunshine <[email-masked]> writes:

> On Wed, Dec 18, 2024 at 8:30 AM shejialuo <[email-masked]> wrote:
>> On Wed, Dec 18, 2024 at 02:20:45AM +0000, AreaZR via GitGitGadget wrote:
>> >               if (is_main_worktree(worktrees[i]))
>> >                       continue;
>> >               ret = 1;
>> > +             break;
>>
>> So, when we find a linked worktree, we just return the value. From my
>> perspective, if we decide to optimize like this way, we could drop the
>> loop because the first element of the result of `get_worktrees` is the
>> main worktree. And we could just check whether the "worktrees[1]" is
>> NULL to do above.
>
> You're correct. get_worktrees() guarantees that the main worktree (or
> bare repository) is the first item in the list, so merely checking
> whether `worktrees[1]` is non-NULL would be sufficient to answer
> whether linked worktrees are present; no looping is required.

Thanks for a well-reasoned write-up.

Would many other callers potentially want to know if the repository
has more than one worktree?  It looks to me that the has_worktrees()
helper function in refs.c is a sign that the worktree API is missing
a function.  Calling get_worktrees() to prepare a list of worktrees
and then counting the result, only to see if there are more than
one, sounds a bit wasteful if we need to do so too often.